# file.make
#
# This file defines the following targets:
# all:	 to build the class files from the java files.
# clean: to clean all sub packages
# doc:   to build the appropriate documentation files from the source
# The 'doc' target uses DESTDIR variable that should point to the absolute 
# path of the target directory (in which doc files will be created).

JAVAC=javac

.SUFFIXES: .java .class

.java.class:
	@@echo "Compiling " $< ; \
	if [ -z "$(TARGET)" ]; then \
		$(JAVAC) $(JAVAFLAGS) $<; \
	else \
		$(JAVAC) -d $(TARGET) $(JAVAFLAGS) $<; \
	fi

all:: $(FILES:.java=.class)

doc::
	javadoc -d $(DESTDIR) $(FILES)

clean::
	@@rm -rf *~ *.class
