/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Original Code is DigitalSesame
 * Portions created by DigitalSesame are Copyright (C) 1997-2000 DigitalSesame
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: CHTMLDomFactory.java,v 1.1.1.1 2003/03/10 16:36:08 taweili Exp $
 */

package org.enhydra.wireless.chtml;

import org.w3c.dom.*;
import org.enhydra.xml.xmlc.XMLCError;
import org.enhydra.xml.xmlc.dom.XMLCDomFactory;
import org.enhydra.xml.xmlc.dom.HTMLDomFactoryMethods;
import org.enhydra.xml.xmlc.dom.xerces.XercesHTMLDomFactory;
import org.enhydra.wireless.chtml.dom.CHTMLDocument;
import org.enhydra.wireless.chtml.dom.xerces.CHTMLDocumentImpl;
import org.enhydra.apache.xerces.dom.DocumentTypeImpl;

/**
 * XMLC DOM factory for XHTML.
 * @see XMLCDomFactory
 */
public class CHTMLDomFactory extends XercesHTMLDomFactory implements XMLCDomFactory {
    /**
     * @see XMLCDomFactory#createDocument
     */
    public Document createDocument(String namespaceURI,
                                   String qualifiedName,
                                   DocumentType docType) {
	return new CHTMLDocumentImpl();
    }
    /**
     * @see XMLCDomFactory#nodeClassToInterface
     */
    public String nodeClassToInterface(Node node) {
        if (node instanceof CHTMLDocument) {
            return CHTMLDocument.class.getName();
        } else {
            return super.nodeClassToInterface(node);
        }
    }
}
