/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Original Code is DigitalSesame
 * Portions created by DigitalSesame are Copyright (C) 1997-2000 DigitalSesame
 * All Rights Reserved.
 * 
 * Contributor(s):
 *     Rex Tsai <chihchun@digitalsesame.com>
 *     David Li <david@digitalsesam.com>
 * 
 * $Id: XHTMLObjectElementImpl.java,v 1.1.1.1 2003/03/10 16:36:11 taweili Exp $
 */

package org.enhydra.xml.xhtml.dom.xerces;

import org.w3c.dom.*;
import org.w3c.dom.html.*;

import org.enhydra.xml.xhtml.dom.*;
import org.enhydra.xml.dom.DOMOps;

public class XHTMLObjectElementImpl 
    extends XHTMLElementImpl 
    implements org.enhydra.xml.xhtml.dom.XHTMLObjectElement 
{

    public XHTMLObjectElementImpl (XHTMLDocumentBase owner, String namespaceURI, String tagName) {
	super( owner, namespaceURI, tagName);
    }

        public void setId (String newValue) {
	setAttribute("id", newValue);
    }

    public String getId () {
	return getAttribute ("id");
    }
    public void setLang (String newValue) {
	setAttribute("lang", newValue);
    }

    public String getLang () {
	return getAttribute ("lang");
    }
    public void setDir (String newValue) {
	setAttribute("dir", newValue);
    }

    public String getDir () {
	return getAttribute ("dir");
    }
    public void setClassName (String newValue) {
	setAttribute("class", newValue);
    }

    public String getClassName () {
	return getAttribute ("class");
    }
    public void setTitle (String newValue) {
	setAttribute("title", newValue);
    }

    public String getTitle () {
	return getAttribute ("title");
    }
    public void setName (String newValue) {
	setAttribute("name", newValue);
    }

    public String getName () {
	return getAttribute ("name");
    }
    public void setType (String newValue) {
	setAttribute("type", newValue);
    }

    public String getType () {
	return getAttribute ("type");
    }
    public void setCodeBase (String newValue) {
	setAttribute("codebase", newValue);
    }

    public String getCodeBase () {
	return getAttribute ("codebase");
    }
    public void setTabIndex (int newValue) {
	setAttribute("tabindex", newValue);
    }

    public int getTabIndex () {
	return getIntAttribute ("tabindex");
    }
    public void setAlign (String newValue) {
	setAttribute("align", newValue);
    }

    public String getAlign () {
	return getAttribute ("align");
    }
    public void setArchive (String newValue) {
	setAttribute("archive", newValue);
    }

    public String getArchive () {
	return getAttribute ("archive");
    }
    public void setCode (String newValue) {
	setAttribute("code", newValue);
    }

    public String getCode () {
	return getAttribute ("code");
    }
    public void setHeight (String newValue) {
	setAttribute("height", newValue);
    }

    public String getHeight () {
	return getAttribute ("height");
    }
    public void setHspace (String newValue) {
	setAttribute("hspace", newValue);
    }

    public String getHspace () {
	return getAttribute ("hspace");
    }
    public void setVspace (String newValue) {
	setAttribute("vspace", newValue);
    }

    public String getVspace () {
	return getAttribute ("vspace");
    }
    public void setWidth (String newValue) {
	setAttribute("width", newValue);
    }

    public String getWidth () {
	return getAttribute ("width");
    }
    public void setBorder (String newValue) {
	setAttribute("border", newValue);
    }

    public String getBorder () {
	return getAttribute ("border");
    }
    public void setUseMap (String newValue) {
	setAttribute("usemap", newValue);
    }

    public String getUseMap () {
	return getAttribute ("usemap");
    }
    public void setCodeType (String newValue) {
	setAttribute("codetype", newValue);
    }

    public String getCodeType () {
	return getAttribute ("codetype");
    }
    public void setData (String newValue) {
	setAttribute("data", newValue);
    }

    public String getData () {
	return getAttribute ("data");
    }
    public void setDeclare (boolean newValue) {
	setAttribute("declare", newValue);
    }

    public boolean getDeclare () {
	return getBooleanAttribute("declare");
    }
    public void setStandby (String newValue) {
	setAttribute("standby", newValue);
    }

    public String getStandby () {
	return getAttribute ("standby");
    }
    public void setOnKeyUp (String newValue) {
	setAttribute("onkeyup", newValue);
    }

    public String getOnKeyUp () {
	return getAttribute ("onkeyup");
    }
    public void setStyle (String newValue) {
	setAttribute("style", newValue);
    }

    public String getStyle () {
	return getAttribute ("style");
    }
    public void setOnMouseDown (String newValue) {
	setAttribute("onmousedown", newValue);
    }

    public String getOnMouseDown () {
	return getAttribute ("onmousedown");
    }
    public void setOnKeyPress (String newValue) {
	setAttribute("onkeypress", newValue);
    }

    public String getOnKeyPress () {
	return getAttribute ("onkeypress");
    }
    public void setOnDblClick (String newValue) {
	setAttribute("ondblclick", newValue);
    }

    public String getOnDblClick () {
	return getAttribute ("ondblclick");
    }
    public void setOnKeyDown (String newValue) {
	setAttribute("onkeydown", newValue);
    }

    public String getOnKeyDown () {
	return getAttribute ("onkeydown");
    }
    public void setOnMouseMove (String newValue) {
	setAttribute("onmousemove", newValue);
    }

    public String getOnMouseMove () {
	return getAttribute ("onmousemove");
    }
    public void setOnMouseUp (String newValue) {
	setAttribute("onmouseup", newValue);
    }

    public String getOnMouseUp () {
	return getAttribute ("onmouseup");
    }
    public void setXmlLang (String newValue) {
	setAttribute("xml:lang", newValue);
    }

    public String getXmlLang () {
	return getAttribute ("xml:lang");
    }
    public void setOnMouseOut (String newValue) {
	setAttribute("onmouseout", newValue);
    }

    public String getOnMouseOut () {
	return getAttribute ("onmouseout");
    }
    public void setOnClick (String newValue) {
	setAttribute("onclick", newValue);
    }

    public String getOnClick () {
	return getAttribute ("onclick");
    }
    public void setOnMouseOver (String newValue) {
	setAttribute("onmouseover", newValue);
    }

    public String getOnMouseOver () {
	return getAttribute ("onmouseover");
    }
    public void setClassid (String newValue) {
	setAttribute("classid", newValue);
    }

    public String getClassid () {
	return getAttribute ("classid");
    }

    /** @see HTMLIFrameElement#getContentDocument() */
    public  Document getContentDocument() {
	return DOMOps.getContentDocument(this);
    }
}


