/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: XercesLinkedHTMLDocument.java,v 1.1.1.1 2003/03/10 16:36:22 taweili Exp $
 */

package org.enhydra.xml.xmlc.dom.xerces;

import org.enhydra.xml.xmlc.XMLObject;
import org.enhydra.xml.xmlc.XMLObjectLink;
import org.enhydra.apache.html.dom.HTMLDocumentImpl;

/**
 * Class that adds XMLObjectLink support to the Xerces HTMLDocument.
 */
public class XercesLinkedHTMLDocument extends HTMLDocumentImpl
                                      implements XMLObjectLink {
    /** Reference to XMLObject containing this Document. */
    private XMLObject fXmlObjectLink;

    /** 
     * Constructor
     */
    public XercesLinkedHTMLDocument() {
    }

    /** @see XMLObjectLink#setXMLObject */
    public void setXMLObject(XMLObject xmlObject) {
        fXmlObjectLink = xmlObject;
    }

    /** @see XMLObjectLink#getXMLObject */
    public XMLObject getXMLObject() {
        return fXmlObjectLink;
    }
}

