/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: FrameTreeHTML.java,v 1.1.1.1 2003/03/10 16:36:28 taweili Exp $
 */

package org.enhydra.xml.xmlc.html;
import org.w3c.dom.*;

/**
 * Interface, originally generated from input/FrameTree.html, but handed
 * edited to be the minimal needed to use classes compiled from this file in
 * tests.  This gives us the ability to generate different classes in
 * different ways and still test the access methods.  The constants have been
 * removed, as we want to make sure they are generated.
 */
public interface FrameTreeHTML extends org.enhydra.xml.xmlc.html.HTMLObject {
    /**
     * Get the element with id <CODE>IMG1</CODE>.
     * @see org.w3c.dom.html.HTMLImageElement
     */
    public org.w3c.dom.html.HTMLImageElement getElementIMG1();

    /**
     * Get the element with id <CODE>IMG2</CODE>.
     * @see org.w3c.dom.html.HTMLImageElement
     */
    public org.w3c.dom.html.HTMLImageElement getElementIMG2();

    /**
     * Get the element with id <CODE>IMG3</CODE>.
     * @see org.w3c.dom.html.HTMLImageElement
     */
    public org.w3c.dom.html.HTMLImageElement getElementIMG3();

    /**
     * Get the element with id <CODE>IMG4</CODE>.
     * @see org.w3c.dom.html.HTMLImageElement
     */
    public org.w3c.dom.html.HTMLImageElement getElementIMG4();

    /**
     * Get the element with id <CODE>placeholderScript</CODE>.
     * @see org.w3c.dom.html.HTMLScriptElement
     */
    public org.w3c.dom.html.HTMLScriptElement getElementPlaceholderScript();

    /**
     * Get the element with id <CODE>table</CODE>.
     * @see org.w3c.dom.html.HTMLTableElement
     */
    public org.w3c.dom.html.HTMLTableElement getElementTable();
}
