/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TestInfo.java,v 1.1.1.1 2003/03/10 16:37:12 taweili Exp $
 */

package org.enhydra.xml.xmlc.servlet.src;

/**
 * Interface implemented by pages to allow setting test information.
 */
public interface TestInfo {
    /**
     * Set the request URL.
     */
    public void setTextRequestURL(String value);

    /**
     * Set the request URI.
     */
    public void setTextRequestURI(String value);

    /**
     * Set the reload count.
     */
    public void setTextReloadCount(String value);

    /**
     * Set the recompile count.
     */
    public void setTextRecompileCount(String value);

    /**
     * Set the session counter .
     */
    public void setTextSessionCounter(String value);

    /**
     * Set the session valid flag .
     */
    public void setTextSessionValid(String value);

    /**
     * Set the session from Cookie flag .
     */
    public void setTextSessionFromCookie(String value);

    /**
     * Set the session from URL flag .
     */
    public void setTextSessionFromURL(String value);

    /**
     * Set the URL encoding mode.
     */
    public void setTextUrlEncoding(String value);

    /**
     * Set the session id.
     */
    public void setTextSessionId(String value);
}
